import java.util.*;
import java.math.*;

public class LinearAlgebra
{
  public static BigInteger ZERO = BigInteger.ZERO;
  public static int[][] buildMatrix(ArrayList<BigInteger> nums,
                                    ArrayList<BigInteger> factorBase)
  {
    int[][] result = new int[factorBase.size()][nums.size()];
    for (int i = 0; i < nums.size(); i++) {
      for (int j = 0; j < factorBase.size(); j++) {
        int entry = 0;
        BigInteger t = nums.get(i);
        BigInteger p = factorBase.get(j);
        while (t.mod(p).equals(ZERO)) {
          entry++;
          t = t.divide(p);
        }
        result[j][i] = entry % 2;
      }
    }
    return result;
  }
}
